describe("RenderEngine", function() {

	var templateManager = {
		"containers": {
			"company": {
				"widgets": [
					{
						"name": "head",
						"label": "Head"
            }
          ],
				"name": "Company"
			}
		}
	};
	var metadataFactory = {
		"containerFactory": function(obj) {
			return obj;
		}
	};
	var renderEngine = new RenderEngine(null, metadataFactory, templateManager, null, null, null, null, new EventAggregator({ bindEvents : function(owner, events){ owner.onRequestError = owner.onRequestRetry =  owner.onRequestSuccess = function(){};  } }));
	//Deve trocar o container do templateManager contruido pelo metadataFactory
	it("Must change container in templateMananger builded of metadataFactory", function() {
		var containerName = "company";
		renderEngine.changeContainer(containerName);
		expect(templateManager.container.name).toEqual("Company");
	});

	it("Must return the widget if there is one", function() {
		var containerName = "company";
		renderEngine.changeContainer(containerName);
		expect(renderEngine.getWidget("head", templateManager.container).label).toEqual("Head");
	});

	//Deve dar erro quando o widget nao existir
	it("Must throw error if there isn't widget", function() {
		var containerName = "company";
		renderEngine.changeContainer(containerName);
		expect(function() {
			var widget = renderEngine.getWidget("head1", templateManager.container);
		}).toThrow(new Error("widget not found"));
	});

});