describe('TabbedWidget Test Suit', function(){

	var scope;
	var tabbedWidget;

	beforeEach(inject(function($rootScope, $window){
		scope = $rootScope.$new();
		var zhPromise = new ZHPromise(Q);
		var templateManager = new TemplateManager($window, zhPromise);

		scope.tabbedWidget = { widget: {} };
		scope.widget = { currentWidget: { name: "DefaultWidget" } };

		tabbedWidget = new TabbedWidget(scope, templateManager);
	}));

	it('$scope.tabClick(): should update currentWidget and widget', function(){
		scope.tabClick({ name: "ClickedWidget" });

		expect(scope.widget).toEqual({ name: "ClickedWidget" });
		expect(scope.tabbedWidget.currentWidget).toEqual({ name: "ClickedWidget" });
	});

});